#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "stdlib.h"

#include "Board.h"
#include "Tile.h"

Board::Board(int width, int height) : 
	m_width(width), m_height(height)
{
	int numTiles = m_width * m_height;
	m_data = (Tile**)malloc(sizeof(Tile*) * numTiles);
	for (int i = 0; i < numTiles; i++)
		m_data[i] = 0;
}

Board::~Board()
{
	if (m_data)
		free(m_data);
}

void Board::CopyRow(int row, char* line)
{
	Tile** ptr = m_data + (row * m_width);
	Tile** endPtr = ptr + m_width;
	char* lp = line;
	
	for (; ptr < endPtr; ptr++, lp++)
	{
		*ptr = new Tile(*lp);
	}
}

void Board::PrintMap(int r, int c)
{
	for (int row = m_height-1; row >= 0; row--)
	{
		printf("%02d: ", row+1);

		for (int col = 0; col < m_width; col++)
		{
			Tile* tile = GetAt(row, col);

			if (row == r && col == c)
				printf("Z");
			else
				printf("%c", tile->m_val);
		}
		
		printf("\n");
	}
}

void Board::SaveMap(char* fn)
{
	FILE* fp = fopen(fn, "w");
	if (fp)
	{
		for (int row = 0; row < m_height; row++)
		{
			for (int col = 0; col < m_width; col++)
			{
				Tile* tile = GetAt(row, col);
				fprintf(fp, "%c", tile->m_val);
			}
			
			fprintf(fp, "\r\n");	// testing on win32
		}			
		fclose(fp);
	}
}
