#ifndef Board_h
#define Board_h

class Tile;
class Server;

///////////////////////////////////////////////////////////////////////
//                         Board class
///////////////////////////////////////////////////////////////////////
class Board
{
	public:
		Board(int width, int height);

		~Board();

		bool Read(Server& server);

		void CopyRow(int row, char* line);

		void PrintMap(int r, int col);								// for debugging
		void SaveMap(char* fn);					// for debugging maps from test server

		int GetWidth() { return m_width; }
		int GetHeight() { return m_height; }

		Tile* GetAt(int row, int col)
		{
			Tile* result = 0;

			if ( (row >= 0) && (col >= 0) && (row < m_height) && (col < m_width))
			{
				Tile** ptr = m_data + (row * m_width) + col;
				result = *ptr;
			}
	
			return result;
		}

	protected:
		int m_width;
		int m_height;
		Tile** m_data;
};

#endif
