#ifndef Client_h
#define Client_h

class Server;
class Board;
class Robot;
class PackageList;

#include "Constants.h"
#include "RobotList.h"

///////////////////////////////////////////////////////////////////////
//                         Client class
///////////////////////////////////////////////////////////////////////
class Client
{
	public:
		Client(Server* server);

		~Client();

		int Run();

	protected:
		bool Init();
		bool ReadBoard();
		bool ReadRobot();
		bool ReadState();

		// Read and return package list, or null if no packages
		bool ReadPackages(PackageList*& pkgList);
	
		bool DoMove();
		bool HandleReply();
		bool ParseReply(char* line);

	protected:
		/////////////////////////////////////////////
		// Event handlers
		/////////////////////////////////////////////

		// Called when new robot found in reply
		void OnNewRobot(int idRobot);

		// Called when robot has been found to be dead
		// (i.e., no longer in reply line)
		void OnDeadRobot(Robot* robot);

	protected:
		Server* m_server;
		Board* m_board;
		Robot* m_robot;
		RobotList m_robotList;
		PackageList* m_curPkgList;
};

#endif