#ifndef Package_h
#define Package_h

class Package
{
	public:
		Package(int id, int x, int y, int weight) :
			m_id(id), m_x(x), m_y(y), m_weight(weight)
		{
			m_prev = m_next = this;
		}

		Package(const Package& copy)
		{
			m_id = copy.m_id;
			m_x = copy.m_x;
			m_y = copy.m_y;
			m_weight = copy.m_weight;
			m_prev = m_next = this;
		}

		int GetID() { return m_id; }
		int GetX() { return m_x; }
		int GetY() { return m_y; }
		int GetWeight() { return m_weight; }
		Package* GetPrev() { return m_prev; }
		Package* GetNext() { return m_next; }

		void SetNext(Package* next) { m_next = next; }
		void SetPrev(Package* prev) { m_prev = prev; }

	protected:
		int m_id;
		int m_x;
		int m_y;
		int m_weight;

		Package* m_prev;
		Package* m_next;
};

#endif