#ifndef PackageList_h
#define PackageList_h

#include "stdio.h"
#include "Package.h"

class PackageList
{
	public:
		PackageList()
		{
			m_root = new Package(-1, -1, -1, -1);
		}
		
		~PackageList()
		{
			// Delete all packages
			Package* cur = GetFirst();
			while (cur != GetEnd())
			{
				Package* next = cur->GetNext();
				delete cur;
				cur = next;
			}
		}

		void AddPackage(Package* pkg)
		{
			pkg->SetPrev(m_root->GetPrev());
			pkg->SetNext(m_root);
			m_root->GetPrev()->SetNext(pkg);
			m_root->SetPrev(pkg);
		}

		void Print()
		{
			printf("--PackageList--\n");

			Package* cur = m_root->GetNext();
			while (cur != m_root)
			{
				printf("\tX=%d, Y=%d, ID=%d, Weight=%d\n", cur->GetX(), cur->GetY(),
					cur->GetID(), cur->GetWeight() );
				cur = cur->GetNext();
			}
		}

		Package* FindByID(int id)
		{
			Package* pkg = 0;
			Package* cur = GetFirst();
			while (cur != GetEnd())
			{
				if (cur->GetID() == id)
				{
					pkg = cur;
					break;
				}
				cur = cur->GetNext();
			}
			return pkg;
		}

		void Unlink(Package* pkg)
		{
			pkg->GetNext()->SetPrev(pkg->GetPrev());
			pkg->GetPrev()->SetNext(pkg->GetNext());
		}

		Package* GetFirst() { return m_root->GetNext(); }
		Package* GetEnd() { return m_root; }

	protected:
		Package* m_root;

};

#endif