#ifndef PathQueue_h
#define PathQueue_h

#include "Path.h"

class PathQueue
{
	public:
		PathQueue()
		{
			m_root = new Path();
		}

		~PathQueue()
		{
			Path* path;
			while ((path = Pop()) != 0)
				delete path;

			if (m_root)
				delete m_root;
		}

		void Push(Path* orig)
		{
			Path* path = new Path(*orig);

			path->SetPrev(m_root->GetPrev());
			path->SetNext(m_root);
			m_root->GetPrev()->SetNext(path);
			m_root->SetPrev(path);
		}

		Path* Pop()
		{
			Path* path = GetTop();
			if (path)
			{
				path->GetNext()->SetPrev(path->GetPrev());
				path->GetPrev()->SetNext(path->GetNext());

				Path* oldPath = path;
				path = new Path(*oldPath);
				delete oldPath;
			}
			return path;
		}

		Path* GetTop()
		{
			Path* path = 0;
			if (m_root->GetNext() != m_root)
			{
				path = m_root->GetNext();
			}
			return path;
		}

	protected:
		Path* m_root;
};

#endif