#ifndef Point_h
#define Point_h

class Point
{
	public:
		Point(int x, int y) : m_x(x), m_y(y)
		{
			m_next = m_prev = this;
		}

		Point(const Point& copy)
		{
			m_x = copy.m_x;
			m_y = copy.m_y;

			m_next = m_prev = this;
		}

		~Point()	
		{
		}

		int GetX() { return m_x; }
		int GetY() { return m_y; }

		Point* GetPrev() { return m_prev; }
		Point* GetNext() { return m_next; }
		void SetPrev(Point* pt) { m_prev = pt; }
		void SetNext(Point* pt) { m_next = pt; }

	protected:
		int m_x;
		int m_y;
		Point* m_prev;
		Point* m_next;
};

#endif