#include "RobotList.h"
#include "Robot.h"

RobotList::RobotList()
{
	m_root = new Robot();
}

RobotList::~RobotList()
{
}

Robot* RobotList::FindRobot(int idRobot)
{
	Robot* target = 0;

	Robot* robot = m_root->GetNext();
	while (robot != m_root)
	{
		int idCur = robot->GetID();

		if (idCur == idRobot)
		{
			// Found target robot
			target = robot;
			break;
		}
		else if (idCur > idRobot)
		{
			// Gone past robot in sorted list
			break;
		}

		robot = robot->GetNext();
	}
	
	return target;
}

Robot* RobotList::CreateRobot(int idRobot)
{
	Robot* robot = new Robot(idRobot, 0, 0);
	if (robot)
	{
		Robot* cur = m_root->GetNext();
		while (cur != m_root)
		{
			if (cur->GetID() > idRobot)
				break;

			cur = cur->GetNext();
		}

		robot->SetPrev(cur->GetPrev());
		robot->SetNext(cur);
		cur->GetPrev()->SetNext(robot);
		cur->SetPrev(robot);
		
	}

	return robot;
}


