#ifndef Server_h
#define Server_h

#ifdef WIN32
	#include "winsock2.h"
#else
	#include "sys/types.h"
	#include "sys/socket.h"
	#include <netinet/in.h>
	#include "netdb.h"
	#include "unistd.h"
	#include "arpa/inet.h"
	#define INVALID_SOCKET -1
	#define SD_BOTH 2
	#define closesocket close
	typedef int SOCKET;
	typedef sockaddr SOCKADDR;
	typedef sockaddr_in SOCKADDR_IN;
	typedef hostent HOSTENT;
#endif

#include "Constants.h"

///////////////////////////////////////////////////////////////////////
//                         Server class
///////////////////////////////////////////////////////////////////////
class Server
{
	public:
		Server(char* addr, int port);

		~Server();

		bool Connect();

		bool SendCmd(const char* line);

		bool ReadLine(char* line);

	protected:
		SOCKET m_Socket;
		char m_buffer[MAX_BUFFER];
		int m_writePos;
		int m_readPos;

		char m_addr[256];
		int m_port;
};

#endif