#ifndef TargetList_h
#define TargetList_h

#include "TargetList.h"
#include "Target.h"
#include "stdio.h"

class TargetList
{
	public:
		TargetList()
		{
			m_root = new Target(-1,-1, false);
		}

		~TargetList()	
		{
			if (m_root)
				delete m_root;
		}

		void AddTarget(Target* target)
		{
			// Append to end of list
			target->SetPrev(m_root->GetPrev());
			target->SetNext(m_root);
			m_root->GetPrev()->SetNext(target);
			m_root->SetPrev(target);
		}

		void AddHead(Target* target)	
		{
			m_root->GetNext()->SetPrev(target);
			target->SetNext(m_root->GetNext());
			target->SetPrev(m_root);
			m_root->SetNext(target);
		}

		void Print()
		{
			return;
			printf("--TargetList--\n");

			Target* cur = m_root->GetNext();
			while (cur != m_root)
			{
				cur->Print();
				cur = cur->GetNext();
			}
		}

		void Unlink(Target* target)
		{
			target->GetNext()->SetPrev(target->GetPrev());
			target->GetPrev()->SetNext(target->GetNext());
		}

		Target* GetFirst() { return m_root->GetNext(); }
		Target* GetEnd() { return m_root; }

	protected:
		Target* m_root;
};

#endif